<script setup>
import Navbar from "../components/Navbar.vue";
import { reactive, ref } from "vue";
import router from "../router";
import { useFetch } from "@vueuse/core";
import { supabase } from "@/supabase";

const imageFile = ref(null)

const dataUser = ref(JSON.parse(localStorage.getItem("koncooUser")))

const formDataCircle = ref({
    name: '',
    image_url: '',
    description: '',
});

const formDataCircleUser = reactive({
    circle_id: '',
    user_id: '',
    role: '1',
});

const handleFileChange = (event) => {
    if (event.target.files.length === 0) return;

    imageFile.value = event.target.files[0]
}

const handleImage = async () => {
    const { data } = await supabase.storage
        .from('koncoo')
        .upload(`${Date.now()}-${imageFile.value?.name}`, imageFile.value);

    const { data: { publicUrl } } = await supabase.storage.from('koncoo').getPublicUrl(data.path)

    formDataCircle.value.image_url = publicUrl
}

const handleCircle = async () => {
    const { isFetching, data, execute: addNewCircle } = useFetch(`${import.meta.env.VITE_API_URL}/circle`, { immediate: false }).post(formDataCircle.value, 'json').json();

    await addNewCircle()

    const { circle_id } = data.value?.data
    formDataCircleUser.circle_id = circle_id
    formDataCircleUser.circle_id = dataUser.value.id
}

const handleCircleUser = async () => {
    const { isFetching, data, execute: addNewCircleUser } = useFetch(`${import.meta.env.VITE_API_URL}/circleuser`, { immediate: false }).post(formDataCircleUser, 'json').json();

    await addNewCircleUser()
}

const { isFetching, data, execute: addNewCircleUser } = useFetch(`${import.meta.env.VITE_API_URL}/circleuser`, { immediate: false }).post(formDataCircleUser, 'json').json();




const handleSubmit = async () => {
    await handleImage();

    try {
        const res = await fetch(`${import.meta.env.VITE_API_URL}/circle`, {
            method: 'POST',
            headers: {
                'Content-Type': 'application/json;charset=UTF-8'
            },
            body: JSON.stringify(formDataCircle.value)
        }).then((response) => response.json())
            .then((data) => {
                formDataCircleUser.circle_id = String(data.data.circle_id)
                formDataCircleUser.user_id = String(dataUser.value.id)
            });

        await addNewCircleUser()

        formDataCircle.value.name = ''
        formDataCircle.value.image_url = null
        formDataCircle.value.description = ''

    } catch (err) {
        console.log(err.message)

    }
}


</script>

<template>
    <div>
        <Navbar class="z-10" title="Add Circle" />
        <div class="content">
            <div>
                <div class="container pt-4 overflow-y-auto h-screen p-5">
                    <form @submit.prevent="handleSubmit">
                        <div class="mb-3">
                            <label for="nameInput" class="form-label">Name</label>
                            <input v-model="formDataCircle['name']" type="text" class="form-control" id="nameInput"
                                placeholder="Name" />
                        </div>
                        <div class="mb-3">
                            <label for="formFIle" class="form-label">Image Circle</label>
                            <input @change="handleFileChange" class="form-control" type="file" id="formFile"  />
                        </div>
                        <div class="mb-3">
                            <label for="descriptionInput" class="form-label">Description</label>
                            <textarea v-model="formDataCircle['description']" class="form-control"
                                placeholder="Description" id="descriptionInput" style="height: 100px"></textarea>
                        </div>
                        <div class="d-grid gap-2 d-md-flex justify-content-md-end">
                            <button class="btn btn-primary" :disabled="isFetching" type="submit">Add</button>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</template>
